
--[[ Configuration ]]--

local barHeight = 5;
local barWidth = 50;
local barPosX = 40;	-- for HUD
local barPosY = 435; -- for HUD
local drawBarAsHUD = true;

--[[ ---------------------------- ]]--

dofile("sys/lua/hpBar/graphics.lua");
local hpBarImg = {};



if ( drawBarAsHUD ) then
	for i = 1, 32 do	-- Initialization
		hpBarImg[i] = {0, 0};
		hpBarImg[i][1] = DrawRect(0, 0, 0, 0, i, {0, 0, 0}, 2);
		hpBarImg[i][2] = DrawRect(0, 0, 0, 0, i, {0, 0, 0}, 2);
		imagealpha(hpBarImg[i][1], 0.4);
	end
	
	function DrawBar(id)
		if ( player(id, "exists") ) then
			local hpRatio, r, g, b;
			
			hpRatio = player(id, "health")/player(id, "maxhealth");
			
			r, g, b = ConvertHSVtoRGB(hpRatio*120, 1, 1);
			r = r*255;
			g = g*255;
			b = b*255;
			
			UpdateRect(hpBarImg[id][1], barPosX-1, barPosY-1, barWidth+2, barHeight+2, {200, 200, 200});
			UpdateRect(hpBarImg[id][2], barPosX, barPosY, hpRatio*barWidth, barHeight, {r, g, b});
		end
	end
else
	for i = 1, 32 do	-- Initialization
		hpBarImg[i] = {0, 0};
		hpBarImg[i][1] = DrawRect(0, 0, 0, 0, 0, {0, 0, 0}, 1);
		hpBarImg[i][2] = DrawRect(0, 0, 0, 0, 0, {0, 0, 0}, 1);
		imagealpha(hpBarImg[i][1], 0.4);
	end
	
	function DrawBar(id)
		if ( player(id, "exists") ) then
			if ( player(id, "health") > 0 ) then
				local x, y, hpRatio, r, g, b;
				
				hpRatio = player(id, "health")/player(id, "maxhealth");
				
				x = player(id, "x") - (barWidth/2);
				y = player(id, "y") - 25;
				
				r, g, b = ConvertHSVtoRGB(hpRatio*120, 1, 1);
				r = r*255;
				g = g*255;
				b = b*255;
				
				UpdateRect(hpBarImg[id][1], x-1, y-1, barWidth+2, barHeight+2, {200, 200, 200});
				UpdateRect(hpBarImg[id][2], x, y, hpRatio*barWidth, barHeight, {r, g, b});
				
				imagealpha(hpBarImg[id][1], 0.4);
				imagealpha(hpBarImg[id][2], 1.0);
			else
				imagealpha(hpBarImg[id][1], 0.0);
				imagealpha(hpBarImg[id][2], 0.0);
			end
		else
			imagealpha(hpBarImg[id][1], 0.0);
			imagealpha(hpBarImg[id][2], 0.0);
		end
	end
end

addhook("always", "DrawHPBars");
function DrawHPBars()
	for i = 1, 32 do
		DrawBar(i);
	end
end
